import es
import cfglib
import vecmath
import playerlib


info = es.AddonInfo()
info.name = 'Dropped Health'
info.version = 1.1
info.basename = 'dropped_health'
info.url = 'http://addons.eventscripts.com/addons/view/dropped_health'
info.author = 'Dead Man Walker'

prop_list = set()

def load():
   createCfg()
   es.addons.registerTickListener(tickListener)

def unload():
   es.addons.unregisterTickListener(tickListener)

def es_map_start(event_var):
   createCfg()

def round_start(event_var):
   if prop_list:
      entity_list = es.createentityindexlist()
      for index in prop_list:
         if index in entity_list:
            es.remove(index)
   prop_list.clear()

def player_death(event_var):
   userid = int(event_var['userid'])
   attacker = int(event_var['attacker'])
   userid_team = event_var['es_userteam']
   attacker_team = event_var['es_attackerteam']
   if (PICKUP_ON_SUICIDE and PICKUP_ON_TEAMKILL) or (attacker not in (0, userid) and userid_team != attacker_team):
      createProp(userid)
   elif attacker in (0, userid) and PICKUP_ON_SUICIDE:
      createProp(userid)
   elif userid_team == attacker_team and PICKUP_ON_TEAMKILL:
      createProp(userid)


def createProp(userid):
   location = es.getplayerlocation(userid)
   es.precachemodel(PICKUP_MODEL_PATH)
   index = es.createentity('prop_dynamic')
   es.entitysetvalue(index, 'model', PICKUP_MODEL_PATH)
   es.entitysetvalue(index, 'origin', "%s %s %s" %location)
   es.spawnentity(index)
   prop_list.add(index)

def tickListener():
   if prop_list:
      for userid in playerlib.getUseridList('#alive'):
         location = es.getplayerlocation(userid)
         to_delete = set()
         for index in prop_list:
            if int(vecmath.distance(es.entitygetvalue(index, 'origin'), (location[0], location[1], location[2]+20))) <= 25 or int(vecmath.distance(es.entitygetvalue(index, 'origin'), (location[0], location[1], location[2]+50))) <= 25:
               player = playerlib.getPlayer(userid)
               if player.health == PICKUP_HEALTH_LIMIT:
                  continue
               elif player.health + PICKUP_HEALTH <= PICKUP_HEALTH_LIMIT:
                  player.health += PICKUP_HEALTH
               else:
                  player.health = PICKUP_HEALTH_LIMIT
               es.playsound(userid, PICKUP_SOUND, PICKUP_SOUND_VOLUME)
               to_delete.add(index)
               es.remove(index)
         for x in to_delete:
            prop_list.discard(x)


def createCfg():
   global PICKUP_MODEL_PATH, PICKUP_SOUND, PICKUP_SOUND_VOLUME, PICKUP_HEALTH, PICKUP_HEALTH_LIMIT
   global PICKUP_ON_SUICIDE, PICKUP_ON_TEAMKILL
   LOOP_INTERVAL = 0.1
   cfg = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + "/cfg/" + info.basename + ".cfg")
   cfg.text("*****************************************************************")
   cfg.text("*** Dropped Health Config")
   cfg.text("*****************************************************************")
   cfg.text(' ')
   CFG_PICKUP_MODEL_PATH = str(cfg.cvar('pickup_model_path', "models/healthvial.mdl", 'Path of the model to be spawned'))
   CFG_PICKUP_SOUND = str(cfg.cvar('pickup_sound', "items/medshot4.wav", 'Path of the sound to be played when the model gets picked up'))
   PICKUP_SOUND_VOLUME = float(cfg.cvar('pickup_sound_volume', 0.7, 'Volume of the sound. 0-1'))
   PICKUP_HEALTH = int(cfg.cvar('pickup_health', 25,'Amount of health to gain'))
   PICKUP_HEALTH_LIMIT = int(cfg.cvar('pickup_health_limit', 100,'Limit of players health. Set to 0 for no limit'))
   PICKUP_ON_SUICIDE = int(cfg.cvar('pickup_on_suicide', 1, 'Dropp health if player committed suicide. 1=yes, 0=no'))
   PICKUP_ON_TEAMKILL = int(cfg.cvar('pickup_on_teamkill', 1, 'Dropp health if death was caused by a teamkill. 1=yes, 0=no'))
   cfg.write()
   cfg.execute()

   if not CFG_PICKUP_MODEL_PATH.startswith("models/"):
      PICKUP_MODEL_PATH = "models/" + CFG_PICKUP_MODEL_PATH
   else:
      PICKUP_MODEL_PATH = CFG_PICKUP_MODEL_PATH
   PICKUP_SOUND = CFG_PICKUP_SOUND.replace("sound/", '')